#ifndef DIAGDATASENDINGWORKER_H
#define DIAGDATASENDINGWORKER_H

#include <QObject>
#include <QTcpServer>
#include <QTcpSocket>
#include <QTextCodec>
#include <QUrl>
#include <QTimer>
#include <QSettings>

#include <QJsonDocument>
#include <QJsonObject>
#include <QJsonParseError>

#include <QNetworkAccessManager>
#include <QHttpPart>
#include <QHttpMultiPart>
#include <QNetworkReply>

class DiagDataSendingWorker : public QTcpServer
{
    Q_OBJECT
public:
    explicit DiagDataSendingWorker(QTcpServer *parent = nullptr);

    void sendData(QJsonDocument diagdata, QString mac);

private slots:
    void startServer();
    void onNewConnection();
    void onClientDisconnect();
    void onReadyRead();

private:
    QTimer *s_timer_restart;
    QList<QTcpSocket*> s_tcpSocketList;

    QStringList m_urls;
    QNetworkAccessManager *m_netMngr;

    bool f_sendingDataToServer{true};

public:
    bool serverStatus{false};

};

#endif // DIAGDATASENDINGWORKER_H
